/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package prodcons;

import java.awt.GridLayout;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import javax.swing.ButtonGroup;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 *
 * @author petr
 */
public class App {

    public static void main(String[] args) {
        ExecutorService pool = Executors.newFixedThreadPool(6);
        SynchronizedBuffer buffer = new SynchronizedBuffer();
        final BufferViewer bv = new BufferViewer(buffer);

        JFrame frame = new JFrame("Producent - konzument");
        frame.setLayout(new GridLayout(1,3));
        JPanel producenti = new JPanel();
        producenti.setLayout(new GridLayout(3,1));
        JPanel konzumenti = new JPanel();
        konzumenti.setLayout(new GridLayout(3,1));

        frame.add(producenti);
        frame.add(bv);
        frame.add(konzumenti);
        JMenuBar mb = new JMenuBar();
        JMenu c = new JMenu("Nastavení");
        ButtonGroup bGroup = new ButtonGroup();

        JRadioButtonMenuItem chbox1 = new JRadioButtonMenuItem("Zobrazovat z prava do leva",true);
        JRadioButtonMenuItem chbox2 = new JRadioButtonMenuItem("Zobrazovat z leva do prava");
        bGroup.add(chbox1);
        bGroup.add(chbox2);
        
        c.add(chbox1);
        c.add(chbox2);
        mb.add(c);
        frame.setJMenuBar(mb);

        chbox1.addChangeListener(new ChangeListener() {

            public void stateChanged(ChangeEvent e) {
                bv.setSmerVypisuBufferu(BufferViewer.SmerVypisu.ZPRAVA);
            }
        });
        chbox2.addChangeListener(new ChangeListener() {

            public void stateChanged(ChangeEvent e) {
                bv.setSmerVypisuBufferu(BufferViewer.SmerVypisu.ZLEVA);
            }
        });


        for (int i = 0; i < 3; i++) {
            Producent p = new Producent(buffer);
            producenti.add(new ProducentView(p));
            pool.submit(p);
            Consumer k = new Consumer(buffer);
            konzumenti.add(new ConsumerView(k));
            pool.submit(k);
        }

        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setSize(600,300);
        frame.setVisible(true);
    }
}
